/*****************************************************
Project   : IO-050 PPS Breakout Box 7s
Version   : 0.1
Date       : --.11.2008

Author   : Oleg D.

Chip type                   : ATtiny2313
Clock frequency        : 8 MHz (RC)
Memory model           : Tiny
External SRAM size  : 0
Data Stack size        : 32
*****************************************************/

#include <tiny2313.h>
#include <delay.h>

#define M_PPS PORTB.7 // PPS
#define PPS PIND.2    // PPS 

#define BUTTON PIND.3 //

#define SEGMENT_7 PORTB //  

#define a 1   //    ,  ,
#define b 2   //   ,   "" 
#define c 4   // ,      
#define d 8 //   .  ,  
#define e 16  // -   ,    
#define f 32  //  255     .
#define g 64  //        .
#define pt 128 //

unsigned char dig[16]; /* ,    ,       ,   
    .     */

char i, k; //i -   , k -     

bit j; //  pps

void __io_init () //  /-----------------------------------
{
DDRA = 0b011; // 
PORTA = 0b100;

DDRB = 0b01111111; //    
SEGMENT_7 = dig[0];

DDRD = 0b1100000; //   PORTD.6 -   
PORTD = 0b1011111;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
} //-------------------------------------------------------------------------------------------------------------------

void __dig_init () //   -------------------
{
  dig[0] = a + b + c + d + e + f;   //     ,
  dig[1] = b + c;           //     
  dig[2] = a + b + g + e + d;     // 255.    , 
  dig[3] = a + b + g + c + d;     //   .
  dig[4] = f + g + b + c;       //   
  dig[5] = a + f + g + c + d;     //   
  dig[6] = a + f + g + c + d + e;
  dig[7] = a + b + c;
  dig[8] = a + b + c + d + e + f + g;
  dig[9] = a + b + c + d + f + g;
  dig[10] = 119; //A
  dig[11] = 124; //B
  dig[12] = 57;  //C
  dig[13] = 94;  //D
  dig[14] = 121; //E
  dig[15] = 113; //F
 } //----------------------------------------------------------------------------------------------------------------

void __segment_7 (char x) //x    < 16,     --
{
 SEGMENT_7 = SEGMENT_7 & 0b10000000; //  

 SEGMENT_7 = SEGMENT_7 | dig [x]; // 
 } //--------------------------------------------------------------------------------------------------------------------------------------

void __segment_7_off () //  -------------------------------
{
 SEGMENT_7 = SEGMENT_7 & 0b10000000; //  
 } //------------------------------------------------------------------------------------------------------------------
 
char __routine (char x) //  -----------------------------------------------------
{

char k_l; //k_l-     

switch (x)
       {
        case 0: DDRB.7 = 0; //  - M_PPS  z 
				__segment_7 (0);
		break;
		
		case 1: __segment_7 (1);
		break;
		
		case 2: __segment_7 (2);
		break;
		
		case 3: __segment_7 (3);
		break;
		
		case 4: __segment_7 (4);
		break;
		
		case 5: __segment_7 (5);
		break;
		
		case 6: __segment_7 (6);
		break;
		
		case 7: __segment_7 (7);
		break;
		
		case 8: DDRB.7 = 1; //  - M_PPS - 
				
				__segment_7 (8);
				
				OCR0A=0x4F; //    79 0x4f
				k_l = 0x01; //    19,68 
		break;
		
		case 9: __segment_7 (9);
				
				OCR0A=0x32; //    50 0x32
				k_l = 0x02; //    19,68/8 
		break;
		
		case 10: __segment_7 (10);

				 OCR0A=0x63; //    99 0x63
				 k_l = 0x02; //    19,68/8  
		break;
		
		case 11: __segment_7 (11);

				 OCR0A=0x94; //    148 0x94
				 k_l = 0x02; //    19,68/8  
		break;
		
		case 12: __segment_7 (12);

				 OCR0A=0xC7; //    199 0x7
				 k_l = 0x02; //    19,68/8  
		break;

		case 13: __segment_7 (13);
				 
				 OCR0A=0xF8; //    248 0xF8
				 k_l = 0x02; //    19,68/8  
		break;

		case 14: __segment_7 (14);

				 OCR0A=0x25; //    37 0x25
				 k_l = 0x03;; //    19,68/64  
		break;

		case 15: __segment_7 (15);

				 OCR0A=0x2B; //    43 0x2B
				 k_l = 0x03;; //    19,68/64  
		break;
		};

return k_l;		
} //--------------------------------------------------------------------------------------------------------------------------------
		
void __interrupt_init () //----------------------------------------------------
{
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x40;
MCUCR=0x01;
EIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK = 0x41; //    / 0, 1

TCNT1H = 0; //   
TCNT1L = 0;

OCR1AH = 0x20; //    8203 0x200b (1,05 c)
OCR1AL = 0x0b;

TCCR1B = 0b00000101; //    8/1024 
} //----------------------------------------------------------------------------------------------------


// External Interrupt 0 service routine***********************************
interrupt [EXT_INT0] void __ext_int0_isr(void)
{
 TCNT0 = 0; // 
 TCCR0B = k; //    

 TCNT1H = 0; //  pps
 TCNT1L = 0;
 
 if (j) // 
    {
	 __segment_7 (i);
	 
	 j = 0;
	 };
} //****************************************************************

// Timer 0 output compare A interrupt service routine*****************************
interrupt [TIM0_COMPA] void __timer0_compa_isr(void)
{
 M_PPS = PPS; //  pps
} //***********************************************************************

// Timer 1 output compare A interrupt service routine*******************************
interrupt [TIM1_COMPA] void __timer1_compa_isr(void)
{
j ^=1; //   pps

if (j) // 
   {	   
    __segment_7_off (); 
	}
else {
      __segment_7 (i);
	  };

TCNT1H = 0; //   
TCNT1L = 0;
	  
TCCR1B = 0b00000101; //    8/1024 
} //*************************************************************************

void main ()
{
__dig_init ();

__io_init (); // /   0- 

__interrupt_init (); //  INT0   

#asm ("sei") //  

while (1)
      {
	   if (!BUTTON) //  
	      {
		   #asm("cli") //   
		   
		   i++; // 
		   
		   if (i == 16) // 16,   0- 
		      {
			   i = 0;
			   };

		   k = __routine (i); // 

		   #asm ("sei") //  

		   while (!BUTTON)
		         { //  
                  delay_ms (100); //    
                  };
           };				     
	   };
}