
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 4,000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : Yes
;8 bit enums            : No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _i=R3
	.DEF _k=R2

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP ___ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP ___timer0_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

;GPIOR0-GPIOR2 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00
	.EQU  __GPIOR1_INIT=0x00
	.EQU  __GPIOR2_INIT=0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;Project   : IO-050 PPS Breakout Box 7s
;Version   : 0.1
;Date       : --.11.2008
;
;Author   : Oleg D.
;
;Chip type                   : ATtiny2313
;Clock frequency        : 8 MHz (RC)
;Memory model           : Tiny
;External SRAM size  : 0
;Data Stack size        : 32
;*****************************************************/
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;#define M_PPS PORTB.7 // PPS
;#define PPS PIND.2    // PPS
;
;#define BUTTON PIND.3 //
;
;#define SEGMENT_7 PORTB //  
;
;#define a 1   //    ,  ,
;#define b 2   //   ,   "" 
;#define c 4   // ,      
;#define d 8 //   .  ,  
;#define e 16  // -   ,    
;#define f 32  //  255     .
;#define g 64  //        .
;#define pt 128 //
;
;unsigned char dig[16]; /* ,    ,       ,   
;    .     */
;
;char i, k; //i -   , k -     
;
;void __io_init () //  /
; 0000 0028 {

	.CSEG
___io_init:
; 0000 0029 DDRA = 0b011; // 
	LDI  R30,LOW(3)
	OUT  0x1A,R30
; 0000 002A PORTA = 0b100;
	LDI  R30,LOW(4)
	OUT  0x1B,R30
; 0000 002B 
; 0000 002C DDRB = 0b01111111; //    
	LDI  R30,LOW(127)
	OUT  0x17,R30
; 0000 002D SEGMENT_7 = dig[0];
	LDS  R30,_dig
	OUT  0x18,R30
; 0000 002E 
; 0000 002F DDRD = 0b1100000; //   PORTD.6 -   
	LDI  R30,LOW(96)
	OUT  0x11,R30
; 0000 0030 PORTD = 0b1011111;
	LDI  R30,LOW(95)
	OUT  0x12,R30
; 0000 0031 
; 0000 0032 // Analog Comparator initialization
; 0000 0033 // Analog Comparator: Off
; 0000 0034 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0035 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0036 }
	RET
;
;void __dig_init () //   
; 0000 0039 {
___dig_init:
; 0000 003A   dig[0] = a + b + c + d + e + f;   //     ,
	LDI  R30,LOW(63)
	STS  _dig,R30
; 0000 003B   dig[1] = b + c;           //     
	LDI  R30,LOW(6)
	__PUTB1MN _dig,1
; 0000 003C   dig[2] = a + b + g + e + d;     // 255.    , 
	LDI  R30,LOW(91)
	__PUTB1MN _dig,2
; 0000 003D   dig[3] = a + b + g + c + d;     //   .
	LDI  R30,LOW(79)
	__PUTB1MN _dig,3
; 0000 003E   dig[4] = f + g + b + c;       //   
	LDI  R30,LOW(102)
	__PUTB1MN _dig,4
; 0000 003F   dig[5] = a + f + g + c + d;     //   
	LDI  R30,LOW(109)
	__PUTB1MN _dig,5
; 0000 0040   dig[6] = a + f + g + c + d + e;
	LDI  R30,LOW(125)
	__PUTB1MN _dig,6
; 0000 0041   dig[7] = a + b + c;
	LDI  R30,LOW(7)
	__PUTB1MN _dig,7
; 0000 0042   dig[8] = a + b + c + d + e + f + g;
	LDI  R30,LOW(127)
	__PUTB1MN _dig,8
; 0000 0043   dig[9] = a + b + c + d + f + g;
	LDI  R30,LOW(111)
	__PUTB1MN _dig,9
; 0000 0044   dig[10] = 119; //A
	LDI  R30,LOW(119)
	__PUTB1MN _dig,10
; 0000 0045   dig[11] = 124; //B
	LDI  R30,LOW(124)
	__PUTB1MN _dig,11
; 0000 0046   dig[12] = 57;  //C
	LDI  R30,LOW(57)
	__PUTB1MN _dig,12
; 0000 0047   dig[13] = 94;  //D
	LDI  R30,LOW(94)
	__PUTB1MN _dig,13
; 0000 0048   dig[14] = 121;  //E
	LDI  R30,LOW(121)
	__PUTB1MN _dig,14
; 0000 0049   dig[15] = 113; //F
	LDI  R30,LOW(113)
	__PUTB1MN _dig,15
; 0000 004A  }
	RET
;
;void __segment_7 (char x) //x    < 16,     
; 0000 004D {
___segment_7:
; 0000 004E  SEGMENT_7 = SEGMENT_7 & 0b10000000; //  
;	x -> Y+0
	IN   R30,0x18
	ANDI R30,LOW(0x80)
	OUT  0x18,R30
; 0000 004F 
; 0000 0050  SEGMENT_7 = SEGMENT_7 | dig [x]; // 
	IN   R30,0x18
	MOV  R26,R30
	LD   R30,Y
	SUBI R30,-LOW(_dig)
	LD   R30,Z
	OR   R30,R26
	OUT  0x18,R30
; 0000 0051  } //-----------------------------------------------------------------------------------------------------------------------------------
	ADIW R28,1
	RET
;
;char __routine (char x) //  
; 0000 0054 {
___routine:
; 0000 0055 
; 0000 0056 char k_l; //k_l-     
; 0000 0057 
; 0000 0058 switch (x)
	ST   -Y,R17
;	x -> Y+1
;	k_l -> R17
	LDD  R30,Y+1
; 0000 0059        {
; 0000 005A         case 0: DDRB.7 = 0; //  - M_PPS  z 
	CPI  R30,0
	BRNE _0x6
	CBI  0x17,7
; 0000 005B 				__segment_7 (0);
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x0
; 0000 005C 		break;
	RJMP _0x5
; 0000 005D 
; 0000 005E 		case 1: __segment_7 (1);
_0x6:
	CPI  R30,LOW(0x1)
	BRNE _0x9
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x0
; 0000 005F 		break;
	RJMP _0x5
; 0000 0060 
; 0000 0061 		case 2: __segment_7 (2);
_0x9:
	CPI  R30,LOW(0x2)
	BRNE _0xA
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x0
; 0000 0062 		break;
	RJMP _0x5
; 0000 0063 
; 0000 0064 		case 3: __segment_7 (3);
_0xA:
	CPI  R30,LOW(0x3)
	BRNE _0xB
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x0
; 0000 0065 		break;
	RJMP _0x5
; 0000 0066 
; 0000 0067 		case 4: __segment_7 (4);
_0xB:
	CPI  R30,LOW(0x4)
	BRNE _0xC
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x0
; 0000 0068 		break;
	RJMP _0x5
; 0000 0069 
; 0000 006A 		case 5: __segment_7 (5);
_0xC:
	CPI  R30,LOW(0x5)
	BRNE _0xD
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x0
; 0000 006B 		break;
	RJMP _0x5
; 0000 006C 
; 0000 006D 		case 6: __segment_7 (6);
_0xD:
	CPI  R30,LOW(0x6)
	BRNE _0xE
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x0
; 0000 006E 		break;
	RJMP _0x5
; 0000 006F 
; 0000 0070 		case 7: __segment_7 (7);
_0xE:
	CPI  R30,LOW(0x7)
	BRNE _0xF
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x0
; 0000 0071 		break;
	RJMP _0x5
; 0000 0072 
; 0000 0073 		case 8: DDRB.7 = 1; //  - M_PPS - 
_0xF:
	CPI  R30,LOW(0x8)
	BRNE _0x10
	SBI  0x17,7
; 0000 0074 
; 0000 0075 				__segment_7 (8);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x0
; 0000 0076 
; 0000 0077 				OCR0A=0x4F; //    79 0x4f
	LDI  R30,LOW(79)
	OUT  0x36,R30
; 0000 0078 				k_l = 0x01; //    19,68 
	LDI  R17,LOW(1)
; 0000 0079 		break;
	RJMP _0x5
; 0000 007A 
; 0000 007B 		case 9: __segment_7 (9);
_0x10:
	CPI  R30,LOW(0x9)
	BRNE _0x13
	LDI  R30,LOW(9)
	RCALL SUBOPT_0x0
; 0000 007C 
; 0000 007D 				OCR0A=0x32; //    50 0x32
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x1
; 0000 007E 				k_l = 0x02; //    19,68/8 
; 0000 007F 		break;
	RJMP _0x5
; 0000 0080 
; 0000 0081 		case 10: __segment_7 (10);
_0x13:
	CPI  R30,LOW(0xA)
	BRNE _0x14
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x0
; 0000 0082 
; 0000 0083 				 OCR0A=0x63; //    99 0x63
	LDI  R30,LOW(99)
	RCALL SUBOPT_0x1
; 0000 0084 				 k_l = 0x02; //    19,68/8 
; 0000 0085 		break;
	RJMP _0x5
; 0000 0086 
; 0000 0087 		case 11: __segment_7 (11);
_0x14:
	CPI  R30,LOW(0xB)
	BRNE _0x15
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x0
; 0000 0088 
; 0000 0089 				 OCR0A=0x94; //    148 0x94
	LDI  R30,LOW(148)
	RCALL SUBOPT_0x1
; 0000 008A 				 k_l = 0x02; //    19,68/8 
; 0000 008B 		break;
	RJMP _0x5
; 0000 008C 
; 0000 008D 		case 12: __segment_7 (12);
_0x15:
	CPI  R30,LOW(0xC)
	BRNE _0x16
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x0
; 0000 008E 
; 0000 008F 				 OCR0A=0xC7; //    199 0x7
	LDI  R30,LOW(199)
	RCALL SUBOPT_0x1
; 0000 0090 				 k_l = 0x02; //    19,68/8 
; 0000 0091 		break;
	RJMP _0x5
; 0000 0092 
; 0000 0093 		case 13: __segment_7 (13);
_0x16:
	CPI  R30,LOW(0xD)
	BRNE _0x17
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x0
; 0000 0094 
; 0000 0095 				 OCR0A=0xF8; //    248 0xF8
	LDI  R30,LOW(248)
	RCALL SUBOPT_0x1
; 0000 0096 				 k_l = 0x02; //    19,68/8 
; 0000 0097 		break;
	RJMP _0x5
; 0000 0098 
; 0000 0099 		case 14: __segment_7 (14);
_0x17:
	CPI  R30,LOW(0xE)
	BRNE _0x18
	LDI  R30,LOW(14)
	RCALL SUBOPT_0x0
; 0000 009A 
; 0000 009B 				 OCR0A=0x25; //    37 0x25
	LDI  R30,LOW(37)
	RJMP _0x25
; 0000 009C 				 k_l = 0x03;; //    19,68/64 
; 0000 009D 		break;
; 0000 009E 
; 0000 009F 		case 15: __segment_7 (15);
_0x18:
	CPI  R30,LOW(0xF)
	BRNE _0x5
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x0
; 0000 00A0 
; 0000 00A1 				 OCR0A=0x2B; //    43 0x2B
	LDI  R30,LOW(43)
_0x25:
	OUT  0x36,R30
; 0000 00A2 				 k_l = 0x03;; //    19,68/64 
	LDI  R17,LOW(3)
; 0000 00A3 		break;
; 0000 00A4 		};
_0x5:
; 0000 00A5 
; 0000 00A6 return k_l;
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,2
	RET
; 0000 00A7 }
;
;void __interrupt_init ()
; 0000 00AA {
___interrupt_init:
; 0000 00AB // External Interrupt(s) initialization
; 0000 00AC // INT0: On
; 0000 00AD // INT0 Mode: Any change
; 0000 00AE // INT1: Off
; 0000 00AF // Interrupt on any change on pins PCINT0-7: Off
; 0000 00B0 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
; 0000 00B1 MCUCR=0x01;
	LDI  R30,LOW(1)
	OUT  0x35,R30
; 0000 00B2 EIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 00B3 
; 0000 00B4 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00B5 TIMSK=0x01; //    / 0
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 00B6 }
	RET
;
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void __ext_int0_isr(void)
; 0000 00BB {
___ext_int0_isr:
	ST   -Y,R30
; 0000 00BC  TCNT0=0x00; // 
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00BD  TCCR0B = k; //    
	OUT  0x33,R2
; 0000 00BE }
	LD   R30,Y+
	RETI
;
;// Timer 0 output compare A interrupt service routine
;interrupt [TIM0_COMPA] void __timer0_compa_isr(void)
; 0000 00C2 {
___timer0_compa_isr:
; 0000 00C3  M_PPS = PPS;
	SBIC 0x10,2
	RJMP _0x1A
	CBI  0x18,7
	RJMP _0x1B
_0x1A:
	SBI  0x18,7
_0x1B:
; 0000 00C4 }
	RETI
;
;void main ()
; 0000 00C7 {
_main:
; 0000 00C8 __dig_init ();
	RCALL ___dig_init
; 0000 00C9 
; 0000 00CA __io_init (); // /   0- 
	RCALL ___io_init
; 0000 00CB 
; 0000 00CC __interrupt_init (); //  INT0
	RCALL ___interrupt_init
; 0000 00CD 
; 0000 00CE while (1)
_0x1C:
; 0000 00CF       {
; 0000 00D0 	   if (!BUTTON) //  
	SBIC 0x10,3
	RJMP _0x1F
; 0000 00D1 	      {
; 0000 00D2 		   #asm("cli") //   
	cli
; 0000 00D3 
; 0000 00D4 		   i++; // 
	INC  R3
; 0000 00D5 
; 0000 00D6 		   if (i == 16) // 16,   0- 
	LDI  R30,LOW(16)
	CP   R30,R3
	BRNE _0x20
; 0000 00D7 		      {
; 0000 00D8 			   i = 0;
	CLR  R3
; 0000 00D9 			   };
_0x20:
; 0000 00DA 
; 0000 00DB 		   k = __routine (i); // 
	ST   -Y,R3
	RCALL ___routine
	MOV  R2,R30
; 0000 00DC 
; 0000 00DD 		   /*if (i > 7) //  
; 0000 00DE 		      {*/
; 0000 00DF 			  #asm ("sei") //  
	sei
; 0000 00E0 			   //};
; 0000 00E1 
; 0000 00E2 		   while (!BUTTON)
_0x21:
	SBIC 0x10,3
	RJMP _0x23
; 0000 00E3 		         { //  
; 0000 00E4                   delay_ms (100); //    
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00E5                   };
	RJMP _0x21
_0x23:
; 0000 00E6            };
_0x1F:
; 0000 00E7 	   };
	RJMP _0x1C
; 0000 00E8 }
_0x24:
	RJMP _0x24

	.DSEG
_dig:
	.BYTE 0x10

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	RJMP ___segment_7

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	OUT  0x36,R30
	LDI  R17,LOW(2)
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
